﻿using HardwareShopContracts.BindingModels;
using HardwareShopContracts.ViewModels;

namespace HardwareShopContracts.BusinessLogicsContracts
{
    public interface IReportStorekeeperLogic
    {
        /// <summary>
        /// Получение списка сборок с указанием, в каких товарах используются
        /// </summary>
        /// <returns></returns>
        List<ReportBuildGoodViewModel> GetBuildGood(List<GoodViewModel> goods);

        /// <summary>
        /// Получение сведений по комплектующим за период, 
        /// с указанием в каких товарах и сборках они использовались
        /// </summary>
        /// <param name="model"></param>
        /// <param name="user"></param>
        /// <returns></returns>
        List<ReportComponentsViewModel> GetComponents(UserBindingModel user, ReportBindingModel model);
    }
}
